#line 1 "C:/Users/Corey/Documents/Projects/Maketing_Projects/Magneto_2/PIC/Magneto2_Click.c"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for pic/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 4 "C:/Users/Corey/Documents/Projects/Maketing_Projects/Magneto_2/PIC/Magneto2_Click.c"
sbit Chip_Select_Direction at TRISE0_bit;
sbit Chip_Select at RE0_bit;


typedef struct MLX
{
 unsigned int angle;
 unsigned int error_code;
 unsigned char buffer[4];
} mlx_t;

mlx_t mlx;

int read_mlx(){
 uint16_t datavalue = 0;
 uint16_t inverted_datavalue = 0;
 uint16_t checkvalue = 0;

 Chip_Select = 0;
 delay_ms(4);
 SPI1_Write(0xAA);
 SPI1_Write(0xFF);
 delay_uS(50);
 mlx.buffer[3]=SPI1_Read(0xFF);
 mlx.buffer[2]=SPI1_Read(0xFF);
 delay_uS(40);
 mlx.buffer[1]=SPI1_Read(0xFF);
 mlx.buffer[0]=SPI1_Read(0xFF);
 delay_us(10);

 Chip_Select = 1;


 datavalue = ((uint16_t) mlx.buffer[3]) << 8;
 datavalue |= ((uint16_t) mlx.buffer[2]);

 checkvalue = datavalue & 1;


 if (checkvalue == 0)
 return -1;
#line 50 "C:/Users/Corey/Documents/Projects/Maketing_Projects/Magneto_2/PIC/Magneto2_Click.c"
 inverted_datavalue = ((uint16_t) mlx.buffer[1]) << 8;
 inverted_datavalue |= ((uint16_t) mlx.buffer[0]);


 if (datavalue != ~inverted_datavalue)
 return -1;

 else
 {
 mlx.angle = datavalue >> 2;
 return 0;
 }

}


void main() {

 char txt[20];
 uint8_t checkit= 0;
 float angle = 0.0;

 UART1_Init( 57600 );
 Delay_ms(300);

 UART1_Write_Text("Uart initialized\r\n");
 Chip_Select_Direction = 0;






 SPI1_Init_Advanced( _SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_END, _SPI_CLK_IDLE_LOW, _SPI_HIGH_2_LOW );
 Delay_ms(400);


 while (1)
 {
 checkit = read_mlx();
 if ( checkit == 0)
 {
 Uart1_Write_Text("Success \r\n");
 angle = (float) mlx.angle;
 angle /= 45.5;
 floattostr(angle,txt);
 Uart1_Write_Text(txt);
 Uart1_Write_Text("\r\n");
 }
 else
 Uart1_Write_Text("Fail \r\n");

 Delay_ms(400);
 }
}
